import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkGoodsSku, ThinkGoodsSkuParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询商品规格表
 */
export async function pageThinkGoodsSku(params: ThinkGoodsSkuParam) {
  const res = await request.get<ApiResult<PageResult<ThinkGoodsSku>>>(
    THINK_API_URL + '/think/think-goods-sku/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品规格表列表
 */
export async function listThinkGoodsSku(params?: ThinkGoodsSkuParam) {
  const res = await request.get<ApiResult<ThinkGoodsSku[]>>(
    THINK_API_URL + '/think/think-goods-sku',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品规格表
 */
export async function addThinkGoodsSku(data: ThinkGoodsSku) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-sku',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品规格表
 */
export async function updateThinkGoodsSku(data: ThinkGoodsSku) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-sku',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品规格表
 */
export async function removeThinkGoodsSku(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-sku/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品规格表
 */
export async function removeBatchThinkGoodsSku(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-goods-sku/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品规格表
 */
export async function getThinkGoodsSku(id: number) {
  const res = await request.get<ApiResult<ThinkGoodsSku>>(
    THINK_API_URL + '/think/think-goods-sku/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
